//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  Orange
#property indicator_color4  Orange
#property indicator_color5  Gray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2

enum enPrices
{
   pr_close,   // Close
   pr_open,    // Open
   pr_high,    // High
   pr_low,     // Low
   pr_median,  // Median
   pr_typical, // Typical
   pr_weighted // Weighted
};

extern enPrices Price                = pr_close; //
extern bool     Adaptive             = true;     //
extern int      LengthShort          = 20;       //
extern int      LengthLong           = 35;       //
extern double   CycleAlfa            = 0.07;     //
extern double   CycleMultiplierShort =    1;     //
extern double   CycleMultiplierLong  =    2;     //
extern bool     CalculateDifference  = false;    //

double histuu[];
double histud[];
double histdd[];
double histdu[];
double RegSlope[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorDigits(_Digits);
   IndicatorBuffers(6);
   SetIndexBuffer(0,histuu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,histud); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,histdd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,histdu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,RegSlope);
   SetIndexBuffer(5,slope);
   string add = ""; if (Adaptive) add = "Adaptive ";
   if (CalculateDifference)
         IndicatorShortName(add+"LinearRegSlope difference("+LengthShort+","+LengthLong+")");
   else  IndicatorShortName(add+"LinearRegSlope ("+LengthShort+")");       
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
          int i,limit = MathMin(Bars-counted_bars,Bars-1);
     
   
   for(int shift=limit;shift>=0;shift--) 
   {	
      double tempLength = LengthShort;
      if (Adaptive)
            tempLength = (int)MathMax(iCustom(NULL,0,"CyclePeriod_v2",Price,CycleAlfa,0,shift)*CycleMultiplierShort,3);
            double SumBars    =  tempLength * (tempLength - 1) * 0.5;
            double SumSqrBars = (tempLength - 1.0) * tempLength * (2.0 * tempLength - 1.0) / 6.0;
            double Sum1       = 0;  for(i=0; i<tempLength; i++) Sum1 += i*iMA(NULL,0,1,0,1,(int)Price,i+shift);
            double SumY       = 0;  for(i=0; i<tempLength; i++) SumY +=   iMA(NULL,0,1,0,1,(int)Price,i+shift);
            double Sum2       = SumBars * SumY;
            double Num1       = tempLength * Sum1 - Sum2;
            double Num2       = SumBars * SumBars - tempLength * SumSqrBars;
            double slopeShort = 0; if( Num2 != 0 ) slopeShort = 100*Num1/Num2;
            
            //
            //
            //
            //
            //
            
            if (CalculateDifference)
            {
               tempLength = LengthLong;
               if (Adaptive)
                  tempLength = (int)MathMax(iCustom(NULL,0,"CyclePeriod_v2",Price,CycleAlfa,0,shift)*CycleMultiplierLong,3);
                  SumBars    =  tempLength * (tempLength - 1) * 0.5;
                  SumSqrBars = (tempLength - 1.0) * tempLength * (2.0 * tempLength - 1.0) / 6.0;
                  Sum1       = 0;  for(i=0; i<tempLength; i++) Sum1 += i*iMA(NULL,0,1,0,1,(int)Price,i+shift);
                  SumY       = 0;  for(i=0; i<tempLength; i++) SumY +=   iMA(NULL,0,1,0,1,(int)Price,i+shift);
                  Sum2       = SumBars * SumY;
                  Num1       = tempLength * Sum1 - Sum2;
                  Num2       = SumBars * SumBars - tempLength * SumSqrBars;
                  double slopeLong = 0; if( Num2 != 0 ) slopeLong = 100*Num1/Num2;
                     RegSlope[shift] = slopeShort-slopeLong;
            }
            else RegSlope[shift] = slopeShort;             
            histuu[shift] = EMPTY_VALUE;
            histud[shift] = EMPTY_VALUE;
            histdd[shift] = EMPTY_VALUE;
            histdu[shift] = EMPTY_VALUE;
            slope[shift]  = slope[shift+1];
               if (RegSlope[shift]>RegSlope[shift+1]) slope[shift]= 1;
               if (RegSlope[shift]<RegSlope[shift+1]) slope[shift]=-1;
               if (RegSlope[shift]>0)
                  if (slope[shift]==1) 
                        histuu[shift] = RegSlope[shift];
                  else  histud[shift] = RegSlope[shift];
               else                  
                  if (slope[shift]==-1) 
                        histdd[shift] = RegSlope[shift];
                  else  histdu[shift] = RegSlope[shift];
   }
	return(0);	
}